﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Runtime.InteropServices;


namespace bosch
{
    public partial class hl : Form
    {
        public hl()
        {
            InitializeComponent();
        }

        /*public string xURL = @"http://www.jobs.cz/pd_search/search?action=jd&design=boschdiesel_cs&exports=28332213&brand=21200101&sourcebrand=jobs.cz&source=jobs&trackingBrand=www.jobs.cz";
        public string xURL_PPT = @"http://bosch.jobs.cz/download/71-temata_dp_bp_aktualni_090326.ppt";
        public int xseconds_to_check = 10;*/
        public int seconds_to_go;
        public WebClient web = new WebClient();

        //string date = DateTime.Now.ToString("yyyy-MM-dd_HH-mm-ss");
        //------------------------------------------------------------------------------------------------------------------
        private void button1_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Opravdu aktualizovat stranku? Pouze pokud se zmenila a furt to vyhazuje zmenenou stranku (treba pokud se na strance zmenilo neco nepodstatneho). Ne pokud tam pribyla nejaka seminarka!", "Otazka", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.No) return;
            Log("Aktualizuju vychozi stranku ... ");
            check_timer.Enabled = false;
            button1.Enabled = false;
            //aktualizuje vychozi soubor
            byte[] data = DownloadFile(URL.Text);
            SaveFile(data, "index.html");
            data = DownloadFile(URL_PPT.Text);
            SaveFile(data, "index.ppt");
            button1.Enabled = true;
            check_timer.Enabled = true;
            Log("HOTOVO" + Environment.NewLine);
        }
        //------------------------------------------------------------------------------------------------------------------
        private byte[] DownloadFile(string _URL)
        {
            try
            {
                return web.DownloadData(_URL);
            }
            catch (Exception e)
            {
                eLog("!!!CHYBA pri stahovani souboru: " + _URL + Environment.NewLine + e.Message);
                return null;
            }
        }
        //------------------------------------------------------------------------------------------------------------------
        private void SaveFile(byte[] data, string file)
        {
            try
            {
                //if (data == null) return;
                FileStream stream;
                if (File.Exists(Environment.CurrentDirectory + "\\data\\" + file)) File.Delete(Environment.CurrentDirectory + "\\data\\" + file);
                stream = File.Open(Environment.CurrentDirectory + "\\data\\" + file, FileMode.CreateNew);
                stream.Write(data, 0, data.Length);
                stream.Close();
            }
            catch (Exception e)
            {
                eLog("!!!CHYBA pri ukladani!!!" + Environment.NewLine + e.Message);
            }
        }
        //------------------------------------------------------------------------------------------------------------------
        private byte[] LoadFile(string file)
        {
            try
            {
                return File.ReadAllBytes(Environment.CurrentDirectory + "\\data\\" + file);
            }
            catch (Exception e)
            {
                eLog("!!!CHYBA pri otvirani!!!" + Environment.NewLine + e.Message);
                return null;
            }
        }
        //------------------------------------------------------------------------------------------------------------------
        public bool ArraysEqual(byte[] ba1, byte[] ba2)
        {
            if ((ba1 == null) || (ba2 == null))
                return false;
            if (ba1.Length != ba2.Length)
                return false;

            for (int i = 0; i < ba1.Length; i++)
            {
                if (ba1[i] != ba2[i])
                    return false;
            }
            return true;
        }
        //------------------------------------------------------------------------------------------------------------------
        private void Log(string text)
        {
            richTextBox1.AppendText(text);
            Application.DoEvents();
        }
        //------------------------------------------------------------------------------------------------------------------
        private void eLog(string text)
        {
            beeper.Enabled = true;
            Show();
            WindowState = FormWindowState.Normal;

            FlashWindowEx(this, (uint)(FLASHWINFOFLAGS.FLASHW_ALL));
            richTextBox1.AppendText(">>> " + text + Environment.NewLine);
            Application.DoEvents();
            MessageBox.Show(text);
            FlashWindowEx(this, (uint)(FLASHWINFOFLAGS.FLASHW_STOP));
            beeper.Enabled = false;
        }
        //------------------------------------------------------------------------------------------------------------------
        private void button2_Click(object sender, EventArgs e)
        {
            check_timer.Enabled = false;
            button2.Enabled = false;
            Zkontroluj();
            button2.Enabled = true;
            check_timer.Enabled = true;
        }
        //------------------------------------------------------------------------------------------------------------------
        private void Zkontroluj()
        {
            Log(DateTime.Now.ToString("yyyy-MM-dd_HH-mm-ss") + ">>> Kontroluju...");
            byte[] data = DownloadFile(URL.Text);
            byte[] data2 = LoadFile("index.html");
            if (!ArraysEqual(data, data2)) eLog("STRANKA SE ZMENILA !!!!!");
            data = DownloadFile(URL_PPT.Text);
            data2 = LoadFile("index.ppt");
            if (!ArraysEqual(data, data2)) eLog("SOUBOR SE ZMENIL !!!!!");
            Log("HOTOVO " + DateTime.Now.ToString("yyyy-MM-dd_HH-mm-ss") + Environment.NewLine);
        }
        //------------------------------------------------------------------------------------------------------------------
        private void Form1_Load(object sender, EventArgs e)
        {
            seconds_to_go = (int)seconds_to_check.Value;
            if (!Directory.Exists(Environment.CurrentDirectory + "\\data\\")) Directory.CreateDirectory(Environment.CurrentDirectory + "\\data\\");
        }
        //------------------------------------------------------------------------------------------------------------------
        private void Form1_Resize(object sender, EventArgs e)
        {
            if (FormWindowState.Minimized == WindowState) Hide();
        }
        //------------------------------------------------------------------------------------------------------------------
        private void notifyIcon1_Click(object sender, EventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
        }
        //------------------------------------------------------------------------------------------------------------------
        #region FlashWindowEx
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool FlashWindowEx(ref FLASHWINFO pwfi);

        [StructLayout(LayoutKind.Sequential)]
        public struct FLASHWINFO
        {
            public UInt32 cbSize;
            public IntPtr hwnd;
            public UInt32 dwFlags;
            public UInt32 uCount;
            public UInt32 dwTimeout;
        }

        public enum FLASHWINFOFLAGS
        {
            FLASHW_STOP = 0,
            FLASHW_CAPTION = 0x00000001,
            FLASHW_TRAY = 0x00000002,
            FLASHW_ALL = (FLASHW_CAPTION | FLASHW_TRAY),
            FLASHW_TIMER = 0x00000004,
            FLASHW_TIMERNOFG = 0x0000000C
        }


        /// Minor adjust to the code above
        /// <summary>
        /// Flashes a window until the window comes to the foreground
        /// Receives the form that will flash
        /// </summary>
        /// <param name="hWnd">The handle to the window to flash</param>
        /// <returns>whether or not the window needed flashing</returns>
        public static bool FlashWindowEx(Form frm, uint flags)
        {
            IntPtr hWnd = frm.Handle;
            FLASHWINFO fInfo = new FLASHWINFO();

            fInfo.cbSize = Convert.ToUInt32(Marshal.SizeOf(fInfo));
            fInfo.hwnd = hWnd;
            //fInfo.dwFlags = (uint) (FLASHWINFOFLAGS.FLASHW_ALL | FLASHWINFOFLAGS.FLASHW_TIMERNOFG);
            //fInfo.dwFlags = (uint)(FLASHWINFOFLAGS.FLASHW_ALL);
            fInfo.dwFlags = flags;
            fInfo.uCount = UInt32.MaxValue;
            fInfo.dwTimeout = 0;

            return FlashWindowEx(ref fInfo);
        }
        #endregion FlashWindowEx
        //------------------------------------------------------------------------------------------------------------------
        private void check_timer_Tick(object sender, EventArgs e)
        {
            check_timer.Enabled = false;
            seconds_to_go = seconds_to_go - 1;
            Text = "BOSCH (" + seconds_to_go.ToString() + "s)";
            if (seconds_to_go <= 0)
            {
                seconds_to_go = (int)seconds_to_check.Value;
                Zkontroluj();
            }
            check_timer.Enabled = true;
        }
        //------------------------------------------------------------------------------------------------------------------
        private void seconds_to_check_ValueChanged(object sender, EventArgs e)
        {
            seconds_to_go = (int)seconds_to_check.Value;
        }
        //------------------------------------------------------------------------------------------------------------------
        private void beeper_Tick(object sender, EventArgs e)
        {
            System.Media.SystemSounds.Exclamation.Play();
            System.Threading.Thread.Sleep(1000);
            System.Console.Beep(4000, 1000);
        }
        //------------------------------------------------------------------------------------------------------------------
        //------------------------------------------------------------------------------------------------------------------
    }
}
